#!/bin/sh

page="$(find "$PASSWORD_STORE_DIR/" -not -regex "$PASSWORD_STORE_DIR/\\..*" \
    -type d | sed -r "s|([^/])$|\1/|")"
# page="${page}\n$(find "$PASSWORD_STORE_DIR/" -type f | sed "s|.gpg$||")"
page="${page}\n$(find "$PASSWORD_STORE_DIR/" -not -regex \
    "$PASSWORD_STORE_DIR/\\..*" -type f | sed "s|.gpg$||")"
page_relative="$(echo "$page" | sed "s|$PASSWORD_STORE_DIR||" | \
    grep -E "^(/[^/]+)?(/[^/]+)/?$")"

page_relative="$(echo "$page_relative" | sort | dmenu -l 15 -i)"
[ -z "$page_relative" ] && exit 0
[ -z "$(echo "$page_relative" | grep -E "^(/[^/]+)(/[^/]+)/?$")" ] && \
    notify-send -t 11000 "The reason to show first level folders is to make use\
 of <TAB> on dmenu and create new password inside them. There should NOT be\
 passwords with first level names." && exit 1

page="$PASSWORD_STORE_DIR$page_relative"

username="$(rofi -dmenu -i -p "Username")"

[ -z "$username" ] && exit 0
[ -d "$page" ] && [ -e "$page$username.gpg" ] && notify-send "Account already \
exists" && exit 1

# mkdir $HOME/.username-store 2> /dev/null

# dir=""
# while [ -n "$( echo "$page" | grep "/" )" ]; do
#     dir="$dir$(echo "$page" | sed "s|/.*$||")/"
#     mkdir $HOME/.username-store/$dir 2> /dev/null
#     page="$(echo "$page" | sed "s|^[^/]*/||")"
# done

# echo "$username" > $HOME/.username-store/$dir$page

comments="$(echo "Yes\nNo" | rofi -dmenu -i -p "Comments?")"

[ -z $(echo "$comments" | grep -E "(Yes|No)") ] && exit 0

generate="$(echo "Yes\nNo" | rofi -dmenu -i -p "Generate password?")"

[ -z $(echo "$generate" | grep -E "(Yes|No)") ] && exit 0

contents="login: $username"
if [ "$generate" = "Yes" ]; then
    contents="$(pwgen -ysBv 15 -N 1)\n$contents"
    if [ "$comments" = "Yes" ]; then
        file="/tmp/comments$(date +%s)"
        $TSCRIPTS/run-on-terminal.sh $EDITOR $file
        # [ -z "${TERMINAL##*termite*}" ] && $TERMINAL -e "$EDITOR \"$file\"" \
        #     || $TERMINAL -e $EDITOR "$file"
        [ -z "$(cat $file)" ] && notify-send "Operation CANCELLED" && exit 1
        contents="$contents\ncomments: $(cat "$file")"
        rm "$file"
    fi
    
    [ -f "$page.gpg" ] && mkdir "$page" && \
        olduser="$(mksh $SCRIPTS/get-pass-username.sh --print \
            "$page_relative")" && mv "$page.gpg" "$page/$olduser.gpg"
    [ -d "$page" ] && page_relative="$page_relative/$username"
    echo "$contents" | pass insert -m "$page_relative" || \
        (notify-send "Already exists" && exit 1)
    # dir="$(echo "$page" | sed "s|[^/]*$||")"
    # page="$(echo "$page" | sed "s|^.*/||")"
    # echo "$username" > "$PASSWORD_STORE_DIR/$dir.$page.user"
else
    # echo "Password: " && stty_orig=`stty -g` && stty -echo && read passwd && \
    #     stty $stty_orig
    tries=0
    while [ "$tries" -ne 3 ]; do
        passwd="$(rofi -i -dmenu -password -p "Type")"
        passwdcheck="$(rofi -i -dmenu -password -p "Type Again")"
        [ "$passwd" != "$passwdcheck" ] || break \
            && notify-send "Passwords are not equal"
        tries="$(( $tries + 1 ))"
    done
    [ "$passwd" != "$passwdcheck" ] && notify-send "Operation CANCELLED" && \
        exit 1
    contents="$passwd\n$contents"
    if [ "$comments" = "Yes" ]; then
        file="/tmp/comments$(date +%s)"
        $TSCRIPTS/run-on-terminal.sh $EDITOR $file
        # [ -z "${TERMINAL##*termite*}" ] && $TERMINAL -e "$EDITOR \"$file\"" \
        #     || $TERMINAL -e $EDITOR "$file"
        contents="$contents\ncomments: $(cat "$file")"
        [ -z "$(cat $file)" ] && notify-send "Operation CANCELLED" && exit 1
        rm "$file"
    fi
    [ -f "$page.gpg" ] && mkdir "$page" && \
        olduser="$(mksh $SCRIPTS/get-pass-username.sh --print \
            "$page_relative")" && mv "$page.gpg" "$page/$olduser.gpg"
    [ -d "$page" ] && page_relative="$page_relative/$username"
    echo "$contents" | pass insert -m "$page_relative" || \
        (notify-send "Already exists" && exit 1)
    # dir="$(echo "$page" | sed "s|[^/]*$||")"
    # page="$(echo "$page" | sed "s|^.*/||")"
    # echo "$username" > "$PASSWORD_STORE_DIR/$dir.$page.user"
fi
