#!/bin/sh

formats="$(mksh -c "echo \$$(echo $1)_FORMATS")"
player="$(mksh -c "echo \$$(echo $1)PLAYER")"

formats="$(echo "$formats" | sed 's/,/\\|/g')"

regex=".*\\.\($formats\)"

trash="\($(echo "$TRASH" | sed 's/:/\/.*\\|/')/.*\)"

multimedia="$(find "$HOME" -regex "$regex" -not -regex "$trash")"
multimedia="$(echo "$multimedia" | sed "s|^$HOME/||")"

multimedia="${multimedia}$(find "$DEVICES_FOLDER" -regex "$regex" \
    -not -regex "$trash")"

media="$(echo "${multimedia}" | dmenu -i -l 9)"

[ "$(echo "$media" | grep -E "$DEVICES_FOLDER/.*" | wc -l)" -eq 0 ] &&
    media="$HOME/$media"

[ "$media" != "$HOME/" ] && mksh -c "$player \"$media\""
