#!/bin/sh

output="/tmp/posix-check-$(date +%s)"
checkbashisms -f $SCRIPTS/*.sh $TSCRIPTS/*.sh > $output 2>&1 

errorline () {
    [ -n "$(echo "$1" | grep '(unsafe echo with backslash)')" ] && echo "1" && \
        return
    [ -n "$(echo "$1" | grep '($"foo" should be eval_gettext "foo")')" ] && \
        echo "1" && return
    [ -n "$(echo "$1" | grep '(\[^\] should be \[!\])')" ] && echo "1" && return
    [ -n "$(echo "$1" | grep -E "bashism in ($SCRIPTS|$TSCRIPTS)/.*\\.sh")" ] && echo "2" && return
    echo "0"
}

bashism="0"
while read -r line
do
    # echo "$(errorline "$line")"
    case "$(errorline "$line")" in
        0) ;;
        1) bashism="0" ;;
        2) bashism="1" ;;
    esac
    [ "$bashism" = "1" ] && echo "$line"
done < $output
